#include <windows.h>
#include <commctrl.h>
#include "resource.h"

#pragma comment( lib, "comctl32.lib" )


LRESULT CALLBACK DlgProcMain(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
void GetFileName(HWND hTextBox);
void GetFileHeader(HWND hTextBox);
BOOL CreateBackup(char * FileName);
void Patch(char * TargetFile);
void CopyFileFrom(HANDLE hSourceFile,HANDLE hTargetFile,DWORD dwStart,DWORD dwLenth);


typedef struct
{
 DWORD Postion;
 DWORD Lenth;
} IndexData;
typedef struct
{
 DWORD IndexFileSize;
 DWORD DataFileSize;
 char  TargetName[MAX_PATH];
 DWORD PatchedFileSize;
} FileHeader;

HINSTANCE hInst=NULL;
HWND hDlg=NULL;

FileHeader fhPatch;
int APIENTRY  WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	hInst=hInstance;
	DialogBox(hInstance, (LPCTSTR)IDD_MAIN, 0, (DLGPROC)DlgProcMain);
	return 0;

}

LRESULT CALLBACK DlgProcMain(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_COMMAND:
		{
	switch( wParam ) 
			{	
		case IDC_APPLY:
			{
				char szFileTargetPath[MAX_PATH];
				char szTextBoxText[MAX_PATH];
				char  *no_use;

				GetDlgItemText(hDlg,IDC_TEXTBOX,szTextBoxText,MAX_PATH);
				GetFullPathName(szTextBoxText,MAX_PATH,szFileTargetPath, &no_use);
				if (CreateBackup(szFileTargetPath)==TRUE)
					Patch(szFileTargetPath);
				else
					MessageBox(hDlg,"Can't make backup.","Error",MB_OK |MB_ICONSTOP );

			break;
			}
		case IDC_OPENFILE:
				{
		GetFileName(GetDlgItem(hWnd,IDC_TEXTBOX));
		
			 break;
				}
			}

			break;
		}

	case WM_INITDIALOG:
		{
		InitCommonControls();
		hDlg=hWnd;
		HICON hIco=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
		SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)hIco);
		GetFileHeader(GetDlgItem(hWnd,IDC_TEXTBOX));
		return true;
		}

	case WM_CLOSE:
		{
			PostQuitMessage(0);
			DestroyWindow(hWnd);
			break;
		}
	case WM_DESTROY:
		{
			PostQuitMessage(0);
			DestroyWindow(hWnd);
			break;
		}

	
	
	}
	return FALSE;
}


void GetFileName(HWND hTextBox)
{
		OPENFILENAME ofn;
		char szFile[MAX_PATH]; 

		ZeroMemory(&ofn, sizeof(ofn));

		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hDlg;
		ofn.lpstrFile = szFile;
		ofn.lpstrFile[0] = '\0';
		ofn.nMaxFile = sizeof(szFile);
		ofn.lpstrFilter = "All Files (*.*)\0*.*\0\0";
		ofn.nFilterIndex = 1;
		ofn.lpstrFileTitle = NULL;
		ofn.nMaxFileTitle = 0;
		ofn.lpstrInitialDir = NULL;
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

		if (GetOpenFileName(&ofn)==TRUE)
			SetWindowText(hTextBox,szFile);
}

void GetFileHeader(HWND hTextBox)
{
	char szFileName[MAX_PATH];
	HANDLE hFile;
	DWORD dwFileSize,dwRead;
	GetModuleFileName(NULL,szFileName,MAX_PATH);

hFile = CreateFile(szFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);	

dwFileSize=GetFileSize(hFile,NULL);

SetFilePointer(hFile,dwFileSize - sizeof(FileHeader),NULL,FILE_BEGIN);

ReadFile(hFile,&fhPatch,sizeof(FileHeader),&dwRead,NULL);

SetWindowText(hTextBox,fhPatch.TargetName);

CloseHandle(hFile);
}

BOOL CreateBackup(char * FileName)
{
char szBakFileName[MAX_PATH];

	if(IsDlgButtonChecked(hDlg,IDC_BACKUP)==BST_CHECKED)
	{
		szBakFileName[0]='0';
		lstrcpy(szBakFileName,FileName);
		lstrcat(szBakFileName,".bak");
		if (CopyFile(FileName,szBakFileName,FALSE)==0)
			return FALSE;
	}

return TRUE;
}

void Patch(char * TargetFile)
{
	char szFileName[MAX_PATH];
	char szTempPath[MAX_PATH];
	char szIndexFileName[MAX_PATH];
	char szDataFileName[MAX_PATH];

	HANDLE hFile,hFileIndex,hFileData;


	GetTempPath(MAX_PATH,szTempPath);
	
	GetTempFileName(szTempPath, "iPM",0,szIndexFileName); 
	GetTempFileName(szTempPath, "dPM",0,szDataFileName); 
	GetModuleFileName(NULL,szFileName,MAX_PATH);

hFileIndex = CreateFile(szIndexFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
hFileData = CreateFile(szDataFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
hFile = CreateFile(szFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);	
	
	if (hFileIndex==INVALID_HANDLE_VALUE || hFileData== INVALID_HANDLE_VALUE || hFile== INVALID_HANDLE_VALUE)
	{
	MessageBox(hDlg,"Error opening temporary files." ,"Error",MB_OK |MB_ICONSTOP);
	CloseHandle(hFileIndex);
	CloseHandle(hFileData);
	CloseHandle(hFile);
	return;
	}


DWORD dwFileSize,dwStartPos;

dwFileSize=GetFileSize(hFile,NULL);


dwStartPos=dwFileSize;
dwStartPos-=sizeof(FileHeader);
dwStartPos-=fhPatch.DataFileSize;
dwStartPos-=fhPatch.IndexFileSize;

CopyFileFrom(hFile,hFileIndex,dwStartPos,fhPatch.IndexFileSize);

dwStartPos=dwFileSize;
dwStartPos-=sizeof(FileHeader);
dwStartPos-=fhPatch.DataFileSize;

CopyFileFrom(hFile,hFileData,dwStartPos,fhPatch.DataFileSize);


char szTempFileName[MAX_PATH];
HANDLE hTempFile,hTargetFile;
DWORD dwTargetFileSize;

GetTempFileName(szTempPath, "tPM",0,szTempFileName);

hTempFile = CreateFile(szTempFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);	
hTargetFile = CreateFile(TargetFile,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);		
	if (hTempFile==INVALID_HANDLE_VALUE || hTargetFile==INVALID_HANDLE_VALUE)
	{
	MessageBox(hDlg,"Error opening temporary files." ,"Error",MB_OK |MB_ICONSTOP);
	CloseHandle(hFileIndex);
	CloseHandle(hFileData);
	CloseHandle(hFile);
	return;
	}

	dwTargetFileSize=GetFileSize(hTargetFile,NULL);

			if (dwTargetFileSize >= fhPatch.PatchedFileSize)
					CopyFileFrom(hTargetFile,hTempFile,0,fhPatch.PatchedFileSize);
			else
				CopyFileFrom(hTargetFile,hTempFile,0,dwTargetFileSize);

	CloseHandle(hFileIndex);
	CloseHandle(hFileData);
	CloseHandle(hFile);
	CloseHandle(hTargetFile);
	CloseHandle(hTempFile);

hFileIndex = CreateFile(szIndexFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);		
hFileData= CreateFile(szDataFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);		
hTempFile = CreateFile(szTempFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);	

DWORD dwIndexRead,dwDataRead,dwTWrite;
IndexData idPatch;
char szTempBuffer[2048];
	do
	{
	ReadFile(hFileIndex,&idPatch,sizeof(IndexData),&dwIndexRead,NULL);
	if (dwIndexRead!=0 )
	{
		if (idPatch.Lenth > 2047)
		{
			CopyFileFrom(hFileData,hTempFile,SetFilePointer(hFileData,0,NULL,FILE_CURRENT),idPatch.Lenth);
		}
		else
		{
	SetFilePointer(hTempFile,idPatch.Postion,NULL,FILE_BEGIN);
	ReadFile(hFileData,szTempBuffer,idPatch.Lenth,&dwDataRead,0);
	WriteFile(hTempFile,szTempBuffer,idPatch.Lenth,&dwTWrite,0);
		}

	}
	}while (dwIndexRead != 0);

	CloseHandle(hFileIndex);
	CloseHandle(hFileData);
	CloseHandle(hTempFile);

	if (DeleteFile(TargetFile)==0)
	{
		MessageBox(hDlg,"Can't delete target file." ,"Error",MB_OK |MB_ICONSTOP);
	return;
	}
	if  (CopyFile(szTempFileName,TargetFile,FALSE)==0)
	{
		MessageBox(hDlg,"Can't create target file." ,"Error",MB_OK |MB_ICONSTOP);
	return;
	}
MessageBox(hDlg,"Patch succeeds.","Info",MB_OK | MB_ICONINFORMATION);

}
void CopyFileFrom(HANDLE hSourceFile,HANDLE hTargetFile,DWORD dwStart,DWORD dwLenth)
{
	DWORD dwCount;
	DWORD dwRead,dwWrite;
	char Buffer[2048];


	dwCount=dwLenth;
	SetFilePointer(hSourceFile,dwStart,NULL,FILE_BEGIN);

		while (dwCount > 0)
		{
			ReadFile(hSourceFile,Buffer,2048,&dwRead,NULL);
			if(dwRead >= dwCount)
					{
					WriteFile(hTargetFile,Buffer,dwCount,&dwWrite,0);
					dwCount=0;
					}
			if (dwCount > dwRead)
					{
				WriteFile(hTargetFile,Buffer,dwRead,&dwWrite,0);
				dwCount -=dwRead;
					}

		}
}