#include <windows.h>
#include <shlwapi.h>
#include <commctrl.h>
#include "resource.h"

#pragma comment( lib, "comctl32.lib" )
#pragma comment( lib, "shlwapi.lib" )

LRESULT CALLBACK DlgProcMain(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgProcAbout(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void MakePatch(char * FileOriginalName,char * FilePatchedName,char * TargetFileName,char * SaveFileName);
void GetFileNames(HWND hTextBox);
BOOL GetSaveFileName(char * szFile);

typedef struct
{
 DWORD Postion;
 DWORD Lenth;
} IndexData;
typedef struct
{
 DWORD IndexFileSize;
 DWORD DataFileSize;
 char  TargetName[MAX_PATH];
 DWORD PatchedFileSize;
} FileHeader;

HINSTANCE hInst=NULL;
HWND hDlg=NULL;
int APIENTRY  WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	hInst=hInstance;
	DialogBox(hInstance, (LPCTSTR)IDD_MAIN, 0, (DLGPROC)DlgProcMain);
	return 0;

}

LRESULT CALLBACK DlgProcMain(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_COMMAND:
		{
	switch( wParam ) 
			{
		case IDC_BUILD:
			{
				char szFileOriginalName[MAX_PATH];
				char szFilePatchedName[MAX_PATH];
				char szTargetFileName[MAX_PATH];
				char szSaveFileName[MAX_PATH];
				BOOL bRet;

				GetDlgItemText(hWnd,IDC_OF_TEXT,szFileOriginalName,MAX_PATH);
				GetDlgItemText(hWnd,IDC_PF_TEXT,szFilePatchedName,MAX_PATH);
				GetDlgItemText(hWnd,IDC_TF_TEXT,szTargetFileName,MAX_PATH);

				bRet=PathFileExists(szFileOriginalName);
					if (bRet==TRUE)
					{
						bRet=PathFileExists(szFilePatchedName);
							if (bRet==TRUE)
							{
									if (lstrlen(szTargetFileName)!=0)
									{
												if (GetSaveFileName(szSaveFileName)==TRUE)
												{
													 PathAddExtension(szSaveFileName,".Exe");
															MakePatch(szFileOriginalName,szFilePatchedName,szTargetFileName,szSaveFileName);														
												}

									}
									else
										MessageBox(hWnd,"Please enter target file name." ,"Error",MB_OK |MB_ICONSTOP);

							}
							else
							MessageBox(hWnd,"Please enter valid patched file name." ,"Error",MB_OK |MB_ICONSTOP);
			
					}
					else
					MessageBox(hWnd,"Please enter valid original file name." ,"Error",MB_OK |MB_ICONSTOP);
			
					

				
				break;
			}
				
			
		case IDC_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUT,hWnd, (DLGPROC)DlgProcAbout);
			break;

		case IDC_EXIT:
			{
				EndDialog(hWnd,0);
			break;
			}


		case IDC_OF:
				{
		GetFileNames(GetDlgItem(hWnd,IDC_OF_TEXT));
		
			 break;
				}
		 
			
		case IDC_PF:
			{
			GetFileNames(GetDlgItem(hWnd,IDC_PF_TEXT));
			char szBuffer[MAX_PATH];
			GetDlgItemText(hWnd,IDC_PF_TEXT,szBuffer,MAX_PATH);
			PathStripPath(szBuffer);
			SetDlgItemText(hWnd,IDC_TF_TEXT,szBuffer);
		    break;
			}


		 }

			break;
		}

	case WM_INITDIALOG:
		{
		InitCommonControls();
		hDlg=hWnd;
		HICON hIco=LoadIcon(hInst,MAKEINTRESOURCE(IDI_PM));
		SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)hIco);
		return true;
		}

	case WM_CLOSE:
		{
			PostQuitMessage(0);
			DestroyWindow(hWnd);
			break;
		}
	case WM_DESTROY:
		{
			PostQuitMessage(0);
			DestroyWindow(hWnd);
			break;
		}

	
	
	}
	return FALSE;
}

void GetFileNames(HWND hTextBox)
{
OPENFILENAME ofn;
 char szFile[MAX_PATH]; 

ZeroMemory(&ofn, sizeof(ofn));

ofn.lStructSize = sizeof(ofn);
ofn.hwndOwner = hDlg;
ofn.lpstrFile = szFile;
ofn.lpstrFile[0] = '\0';
ofn.nMaxFile = sizeof(szFile);
ofn.lpstrFilter = "All Files (*.*)\0*.*\0\0";
ofn.nFilterIndex = 1;
ofn.lpstrFileTitle = NULL;
ofn.nMaxFileTitle = 0;
ofn.lpstrInitialDir = NULL;
ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

if (GetOpenFileName(&ofn)==TRUE)
	SetWindowText(hTextBox,szFile);
}
BOOL GetSaveFileName(char * szFile)
{
OPENFILENAME ofn;


ZeroMemory(&ofn, sizeof(ofn));

ofn.lStructSize = sizeof(ofn);
ofn.hwndOwner = hDlg;
ofn.lpstrFile = szFile;
ofn.lpstrFile[0] = '\0';
ofn.nMaxFile = MAX_PATH;
ofn.lpstrFilter = "Application (*.exe)\0*.exe\0\0";
ofn.nFilterIndex = 1;
ofn.lpstrFileTitle = NULL;
ofn.nMaxFileTitle = 0;
ofn.lpstrInitialDir = NULL;
ofn.Flags = OFN_NODEREFERENCELINKS;

	if (GetSaveFileName(&ofn)==TRUE)
		return TRUE;
	else
		return FALSE;
}
LRESULT CALLBACK DlgProcAbout(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_COMMAND:
		{
			if (LOWORD(wParam) == IDC_OK)
				EndDialog(hWnd,1);
			if (LOWORD(wParam) == IDC_WEB)
				ShellExecute(NULL,"open","http://www.geocities.com/arshadlati",NULL,NULL,SW_SHOWNORMAL);

			break;
		}

	case WM_INITDIALOG:
		{ 
			HICON hIco=LoadIcon(NULL,IDI_INFORMATION);
			SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)hIco);
		return true;
		}

		
	case WM_CLOSE:
		{
		EndDialog(hWnd,1);
			break;
		}
	}
	return FALSE;
}
void MakePatch(char * FileOriginalName,char * FilePatchedName,char * TargetFileName,char * SaveFileName)
{
	char szTempPath[MAX_PATH];
	char szIndexFileName[MAX_PATH];
	char szDataFileName[MAX_PATH];

	HANDLE hFileIndex,hFileData,hFileOriginal,hFilePatched,hFileSave;

	GetTempPath(MAX_PATH,szTempPath);
	
	GetTempFileName(szTempPath, "iPM",0,szIndexFileName); 
	GetTempFileName(szTempPath, "dPM",0,szDataFileName); 


hFileIndex = CreateFile(szIndexFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
hFileData = CreateFile(szDataFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	
	if (hFileIndex==INVALID_HANDLE_VALUE || hFileData== INVALID_HANDLE_VALUE)
	{
	MessageBox(hDlg,"Error opening temporary file." ,"Error",MB_OK |MB_ICONSTOP);
	CloseHandle(hFileIndex);
	CloseHandle(hFileData);
	return;
	}

hFileOriginal = CreateFile(FileOriginalName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);	
	
	if (hFileOriginal==INVALID_HANDLE_VALUE)
	{
	MessageBox(hDlg,"Error opening original file." ,"Error",MB_OK |MB_ICONSTOP);
	CloseHandle(hFileIndex);
	CloseHandle(hFileData);
	return;
	}
hFilePatched = CreateFile(FilePatchedName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);	
	
	if (hFilePatched==INVALID_HANDLE_VALUE)
	{
	MessageBox(hDlg,"Error opening Patched file." ,"Error",MB_OK |MB_ICONSTOP);
	CloseHandle(hFileIndex);
	CloseHandle(hFileData);
	CloseHandle(hFileOriginal);
	return;
	}

hFileSave = CreateFile(SaveFileName,GENERIC_WRITE,NULL,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,NULL);	
	
	if (hFileSave==INVALID_HANDLE_VALUE)
	{
	MessageBox(hDlg,"Cant create output application file." ,"Error",MB_OK |MB_ICONSTOP);
	CloseHandle(hFileIndex);
	CloseHandle(hFileData);
	CloseHandle(hFileOriginal);
	CloseHandle(hFilePatched);
	return;
	}

char lpPatchedBuffer[2048];
char lpOriginalBuffer[2048];
DWORD dwRead,dwOriRead,dwPFilePos,dwWrite,dwOriFileSize,dwPatchFileSize,dwNumWrite=0,dwIndPos;
IndexData idIndex;
DWORD i;
bool bDiff=false;
DWORD DiffStart=0;

dwOriFileSize=GetFileSize(hFileOriginal,NULL);
dwPatchFileSize=GetFileSize(hFilePatched,NULL);
if (dwOriFileSize < dwPatchFileSize)
{
		do
		{
		dwPFilePos=SetFilePointer(hFilePatched,0,NULL,FILE_CURRENT);
		dwIndPos=dwPFilePos;
		bDiff=false;
		ReadFile(hFilePatched,lpPatchedBuffer,2048,&dwRead,NULL);
		ReadFile(hFileOriginal,lpOriginalBuffer,2048,&dwOriRead,NULL);

			if (dwOriRead !=0 )
			{
		for (i=0;i < dwOriRead;i++)
		{
			

					if (lpOriginalBuffer[i]!=lpPatchedBuffer[i])
					{
						
						if (i==dwOriRead -1)
						{
								if(bDiff==true)
								{
								idIndex.Lenth=dwIndPos - DiffStart;
								idIndex.Postion=DiffStart;
							
								WriteFile(hFileData,&lpPatchedBuffer[i- idIndex.Lenth],idIndex.Lenth +1,&dwWrite,0);
								idIndex.Lenth++;
								WriteFile(hFileIndex,&idIndex,sizeof(IndexData),&dwWrite,0);
								
								}
								else
								{
								idIndex.Lenth=1;
								idIndex.Postion=dwIndPos;
								WriteFile(hFileIndex,&idIndex,sizeof(IndexData),&dwWrite,0);
							
								WriteFile(hFileData,&lpPatchedBuffer[i],1,&dwWrite,0);
								}

						}
						else
						{
						if(bDiff!=true)
						{
							DiffStart=dwIndPos;
							bDiff=true;
						}
						}
						
						
					}
					else
					{
							if(bDiff==true)
							{
								idIndex.Lenth=dwIndPos - DiffStart;
								idIndex.Postion=DiffStart;
								WriteFile(hFileIndex,&idIndex,sizeof(IndexData),&dwWrite,0);
								
								WriteFile(hFileData,&lpPatchedBuffer[i- idIndex.Lenth],idIndex.Lenth,&dwWrite,0);
								bDiff=false;
							}
							
					}
					dwIndPos++;
		}


			
			}

		}while (dwOriRead != 0);
}









if (dwOriFileSize >= dwPatchFileSize)
{
		do
		{
		dwPFilePos=SetFilePointer(hFilePatched,0,NULL,FILE_CURRENT);
		dwIndPos=dwPFilePos;
		bDiff=false;
		ReadFile(hFilePatched,lpPatchedBuffer,2048,&dwRead,NULL);
		ReadFile(hFileOriginal,lpOriginalBuffer,2048,&dwOriRead,NULL);

			if (dwRead !=0 )
			{
		for (i=0;i < dwRead;i++)
		{
					

					if (lpOriginalBuffer[i]!=lpPatchedBuffer[i])
					{
						
						if (i==dwRead -1)
						{
								if(bDiff==true)
								{
								idIndex.Lenth=dwIndPos - DiffStart;
								idIndex.Postion=DiffStart;
								
							
								WriteFile(hFileData,&lpPatchedBuffer[i- idIndex.Lenth],idIndex.Lenth +1,&dwWrite,0);
								idIndex.Lenth++;
								WriteFile(hFileIndex,&idIndex,sizeof(IndexData),&dwWrite,0);
								}
								else
								{
								idIndex.Lenth=1;
								idIndex.Postion=dwIndPos;
								WriteFile(hFileIndex,&idIndex,sizeof(IndexData),&dwWrite,0);
							
								WriteFile(hFileData,&lpPatchedBuffer[i],1,&dwWrite,0);
								}

						}
						else
						{
						if(bDiff!=true)
						{
							DiffStart=dwIndPos;
							bDiff=true;
						}
						}
						
						
					}
					else
					{
							if(bDiff==true)
							{
								idIndex.Lenth=dwIndPos - DiffStart;
								idIndex.Postion=DiffStart;
								WriteFile(hFileIndex,&idIndex,sizeof(IndexData),&dwWrite,0);
								
								WriteFile(hFileData,&lpPatchedBuffer[i- idIndex.Lenth],idIndex.Lenth,&dwWrite,0);
								bDiff=false;
							}
							
					}
					dwIndPos++;
		}

			
			
			}

		}while (dwRead != 0);
}





if (dwOriFileSize < dwPatchFileSize)
{
	dwPFilePos=SetFilePointer(hFilePatched,dwOriFileSize,NULL,FILE_BEGIN);
	dwNumWrite=0;
	do
	{

	ReadFile(hFilePatched,lpPatchedBuffer,2048,&dwRead,NULL);
	
	if (dwRead !=0 )
	{
	WriteFile(hFileData,lpPatchedBuffer,dwRead,&dwWrite,0);
    dwNumWrite+=dwWrite;
	}

	}while (dwRead != 0);

	idIndex.Lenth=dwNumWrite;
	idIndex.Postion=dwOriFileSize;
	WriteFile(hFileIndex,&idIndex,sizeof(IndexData),&dwWrite,0);
}




CloseHandle(hFileIndex);
CloseHandle(hFileData);
hFileIndex = CreateFile(szIndexFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
hFileData = CreateFile(szDataFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

FileHeader fhOut;

fhOut.DataFileSize=GetFileSize(hFileData,NULL);
fhOut.IndexFileSize=GetFileSize(hFileIndex,NULL);
fhOut.PatchedFileSize=dwPatchFileSize;

ZeroMemory((LPVOID)fhOut.TargetName,MAX_PATH);
lstrcpy(fhOut.TargetName,TargetFileName);



HRSRC hResLoad; 
HRSRC hRes;
char *lpResLock;
DWORD dwResSize;

hRes = FindResource(NULL,"#106", "RT_RCDATA"); 

dwResSize=SizeofResource(NULL,hRes);

hResLoad=(HRSRC)LoadResource(NULL,hRes); 
  
lpResLock =(char *) LockResource(hResLoad);

WriteFile(hFileSave,lpResLock,dwResSize,&dwWrite,0);



char NullByte[256];
ZeroMemory((LPVOID) NullByte,256);

WriteFile(hFileSave,NullByte,256,&dwWrite,0);





	do
	{
	ReadFile(hFileIndex,lpPatchedBuffer,2048,&dwRead,NULL);
	if (dwRead !=0 )
	WriteFile(hFileSave,lpPatchedBuffer,dwRead,&dwWrite,0);
	}while (dwRead != 0);


	do
	{
	ReadFile(hFileData,lpPatchedBuffer,2048,&dwRead,NULL);
	if (dwRead !=0 )
	WriteFile(hFileSave,lpPatchedBuffer,dwRead,&dwWrite,0);
	}while (dwRead != 0);

	WriteFile(hFileSave,&fhOut,sizeof(FileHeader),&dwWrite,0);




CloseHandle(hFileIndex);
CloseHandle(hFileData);
CloseHandle(hFileOriginal);
CloseHandle(hFilePatched);
CloseHandle(hFileSave);

MessageBox(hDlg,"Making patch succeeds.","Info",MB_OK | MB_ICONINFORMATION);

}